#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>

#include "defs.h"
#include "smtp.h"
#include "config.h"

int
parse_header() {
	FILE	*fd;
	char	line[MIDBUFSIZE];
	char	*str;
	char	*tmp;

	if((fd = fopen("_headers_", "r")) == NULL) {
#ifdef DEBUG
		printf("Error: fopen _headers_\n");
#endif
		return -1;
	}

	memset(rfc821_from, 0, sizeof(rfc821_from));
	memset(rfc821_to, 0, sizeof(rfc821_to));
	memset(rfc821_subj, 0, sizeof(rfc821_subj));
	memset(rfc821_name, 0, sizeof(rfc821_name));

	while(fgets(line, MIDBUFSIZE-1, fd)) {
		if (line[0] == '\n') break;
		line[strlen(line)-1] = '\0';

		if((!strncmp(line, "From:", 5) || !strncmp(line, "from:", 5) || !strncmp(line, "FROM:", 5)) && rfc821_from[0] == '\0') {
			if((str = strchr(line, ':')) == NULL) continue;
			str++;
			while(*str == ' ') str++;
			if(*str == '\0') continue;
			if((tmp = strchr(str, '<')) != NULL) {
				tmp++;
				str = tmp;
				while((*tmp != '>') && (*tmp != '\0')) tmp++;
				*tmp = '\0';
			}
			if(strchr(str, '@') != NULL) strncpy(rfc821_from, str, sizeof(rfc821_from)-1);
		}
		else if((!strncmp(line, "To:", 3) || !strncmp(line, "TO:", 3) || !strncmp(line, "to:", 3)) && rfc821_to[0] == '\0') {
			if((str = strchr(line, ':')) == NULL) continue;
			str++;
			while(*str == ' ') str++;
			if(*str == '\0') continue;
			if((tmp = strchr(str, '<')) != NULL) {
				tmp++;
				str = tmp;
				while((*tmp != '>') && (*tmp != '\0')) tmp++;
				*tmp = '\0';
			}
			strncpy(rfc821_to, str, sizeof(rfc821_to)-1);
		}
		else if((!strncmp(line, "Subject:", 8) || !strncmp(line, "subject:", 8) || !strncmp(line, "SUBJECT:", 8)) && rfc821_subj[0] == '\0') {
			if((str = strchr(line, ':')) == NULL) continue;
			str++;
			while(*str == ' ') str++;
			if(*str == '\0') continue;
			strncpy(rfc821_subj, str, sizeof(rfc821_subj)-1);
		}
		else if(strncmp(line, "Content-Type: text/html;", 24) == 0) {
			if((str = strstr(line, "name=")) != NULL) {
				str = str + 5;
				strncpy(rfc821_name, str, sizeof(rfc821_name)-1);
				while((*str != '\0') && (*str != ';') && (*str != ' ') && (*str != '\t') && (*str != '\n'))
					str++;
				*str = '\0';
			}
		}
	}

	if(strlen(rfc821_from) == 0) strncpy(rfc821_from, "unknown", sizeof(rfc821_from)-1);
	if(strlen(rfc821_to) == 0) strncpy(rfc821_to, "unknown", sizeof(rfc821_to)-1);
	if(strlen(rfc821_subj) == 0) strncpy(rfc821_subj, "no subject", sizeof(rfc821_subj)-1);

	fclose(fd);

#ifdef DEBUG
	printf("Recvfrom: '%s'\n", rfc821_recvfrom);
	printf("From: '%s'\n", rfc821_from);
	printf("To: '%s'\n", rfc821_to);
	printf("Subject: '%s'\n", rfc821_subj);
	printf("Name: '%s'\n", rfc821_name);
#endif

	return 0;
}

